Loading...
Searching...
No Matches
wayland::server::zwp_tablet_pad_v2_t Class Reference

a set of buttons, rings and strips More...

`#include <wayland-server-protocol-unstable.hpp>`

## Public Member Functions

std::function< void(uint32_t, std::string, uint32_t)> & | on_set_feedback ()
| set compositor feedback
std::function< void()> & | on_destroy ()
| destroy the pad object
void | group (bool post=true)
| group announced
void | path (std::string const &path, bool post=true)
| path to the device
void | buttons (uint32_t buttons, bool post=true)
| buttons announced
void | done (bool post=true)
| pad description event sequence complete
void | button (uint32_t time, uint32_t button, zwp_tablet_pad_v2_button_state const &state, bool post=true)
| physical button state
void | enter (uint32_t serial, zwp_tablet_v2_t const &tablet, surface_t const &surface, bool post=true)
| enter event
void | leave (uint32_t serial, surface_t const &surface, bool post=true)
| enter event
void | removed (bool post=true)
| pad removed event
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
void | post_no_memory () const
uint32_t | get_id () const
client_t | get_client () const
unsigned int | get_version () const
std::string | get_class ()

## Static Public Attributes

static constexpr std::uint32_t | group_since_version = 1
| Minimum protocol version required for the group function.
static constexpr std::uint32_t | path_since_version = 1
| Minimum protocol version required for the path function.
static constexpr std::uint32_t | buttons_since_version = 1
| Minimum protocol version required for the buttons function.
static constexpr std::uint32_t | done_since_version = 1
| Minimum protocol version required for the done function.
static constexpr std::uint32_t | button_since_version = 1
| Minimum protocol version required for the button function.
static constexpr std::uint32_t | enter_since_version = 1
| Minimum protocol version required for the enter function.
static constexpr std::uint32_t | leave_since_version = 1
| Minimum protocol version required for the leave function.
static constexpr std::uint32_t | removed_since_version = 1
| Minimum protocol version required for the removed function.

## Detailed Description

a set of buttons, rings and strips

A pad device is a set of buttons, rings and strips usually physically present on the tablet device itself. Some exceptions exist where the pad device is physically detached, e.g. the Wacom ExpressKey Remote.

Pad devices have no axes that control the cursor and are generally auxiliary devices to the tool devices used on the tablet surface.

A pad device has a number of static characteristics, e.g. the number of rings. These capabilities are sent in an event sequence after the wp_tablet_seat.pad_added event before any actual events from this pad. This initial event sequence is terminated by a wp_tablet_pad.done event.

All pad features (buttons, rings and strips) are logically divided into groups and all pads have at least one group. The available groups are notified through the wp_tablet_pad.group event; the compositor will emit one event per group before emitting wp_tablet_pad.done.

Groups may have multiple modes. Modes allow clients to map multiple actions to a single pad feature. Only one mode can be active per group, although different groups may have different active modes.

Definition at line 6189 of file wayland-server-protocol-unstable.hpp.

## Member Function Documentation

## button()

void zwp_tablet_pad_v2_t::button | ( | uint32_t | time,
|  | uint32_t | button,
|  | zwp_tablet_pad_v2_button_state const & | state,
|  | bool | post = true )

physical button state

Parameters

  time | the time of the event with millisecond granularity
  button | the index of the button that changed state
  state |

Sent whenever the physical state of a button changes.

Definition at line 6932 of file wayland-server-protocol-unstable.cpp.

## buttons()

void zwp_tablet_pad_v2_t::buttons | ( | uint32_t | buttons,
|  | bool | post = true )

buttons announced

Parameters

  buttons | the number of buttons

Sent on wp_tablet_pad initialization to announce the available buttons.

This event is sent in the initial burst of events before the wp_tablet_pad.done event. This event is only sent when at least one button is available.

Definition at line 6922 of file wayland-server-protocol-unstable.cpp.

## done()

void zwp_tablet_pad_v2_t::done | ( | bool | post = true | ) |

pad description event sequence complete

This event signals the end of the initial burst of descriptive events. A client may consider the static description of the pad to be complete and finalize initialization of the pad.

Definition at line 6927 of file wayland-server-protocol-unstable.cpp.

## enter()

void zwp_tablet_pad_v2_t::enter | ( | uint32_t | serial,
|  | zwp_tablet_v2_t const & | tablet,
|  | surface_t const & | surface,
|  | bool | post = true )

enter event

Parameters

  serial | serial number of the enter event
  tablet | the tablet the pad is attached to
  surface | surface the pad is focused on

Notification that this pad is focused on the specified surface.

Definition at line 6937 of file wayland-server-protocol-unstable.cpp.

## get_class()

std::string wayland::server::resource_t::get_class | ( |  | ) |

inherited

Retrieve the interface name (class) of a resource object.

Returns
  Interface name of the resource object.

## get_client()

client_t wayland::server::resource_t::get_client | ( |  | ) | const

inherited

Get the associated client

Returns
  the client that owns the resource.

## get_id()

uint32_t wayland::server::resource_t::get_id | ( |  | ) | const

inherited

Get the internal ID of the resource

Returns
  the internal ID of the resource

## get_version()

unsigned int wayland::server::resource_t::get_version | ( |  | ) | const

inherited

Get interface version

Returns
  Interface version this resource has been constructed with.

## group()

void zwp_tablet_pad_v2_t::group | ( | bool | post = true | ) |

group announced

Sent on wp_tablet_pad initialization to announce available groups. One event is sent for each pad group available.

This event is sent in the initial burst of events before the wp_tablet_pad.done event. At least one group will be announced.

Definition at line 6912 of file wayland-server-protocol-unstable.cpp.

## leave()

void zwp_tablet_pad_v2_t::leave | ( | uint32_t | serial,
|  | surface_t const & | surface,
|  | bool | post = true )

enter event

Parameters

  serial | serial number of the leave event
  surface | surface the pad is no longer focused on

Notification that this pad is no longer focused on the specified surface.

Definition at line 6942 of file wayland-server-protocol-unstable.cpp.

## on_destroy()

std::function< void()> & zwp_tablet_pad_v2_t::on_destroy | ( |  | ) |

destroy the pad object

Destroy the wp_tablet_pad object. Objects created from this object are unaffected and should be destroyed separately.

Definition at line 6906 of file wayland-server-protocol-unstable.cpp.

## on_set_feedback()

std::function< void(uint32_t, std::string, uint32_t)> & zwp_tablet_pad_v2_t::on_set_feedback | ( |  | ) |

set compositor feedback

Parameters

  button | button index
  description | button description
  serial | serial of the mode switch event

Requests the compositor to use the provided feedback string associated with this button. This request should be issued immediately after a wp_tablet_pad_group.mode_switch event from the corresponding group is received, or whenever a button is mapped to a different action. See wp_tablet_pad_group.mode_switch for more details.

Clients are encouraged to provide context-aware descriptions for the actions associated with each button, and compositors may use this information to offer visual feedback on the button layout (e.g. on-screen displays).

Button indices start at 0. Setting the feedback string on a button that is reserved by the compositor (i.e. not belonging to any wp_tablet_pad_group) does not generate an error but the compositor is free to ignore the request.

The provided string 'description' is a UTF-8 encoded string to be associated with this ring, and is considered user-visible; general internationalization rules apply.

The serial argument will be that of the last wp_tablet_pad_group.mode_switch event received for the group of this button. Requests providing other serials than the most recent one will be ignored.

Definition at line 6900 of file wayland-server-protocol-unstable.cpp.

## path()

void zwp_tablet_pad_v2_t::path | ( | std::string const & | path,
|  | bool | post = true )

path to the device

Parameters

  path | path to local device

A system-specific device path that indicates which device is behind this wp_tablet_pad. This information may be used to gather additional information about the device, e.g. through libwacom.

The format of the path is unspecified, it may be a device node, a sysfs path, or some other identifier. It is up to the client to identify the string provided.

This event is sent in the initial burst of events before the wp_tablet_pad.done event.

Definition at line 6917 of file wayland-server-protocol-unstable.cpp.

## post_no_memory()

void wayland::server::resource_t::post_no_memory | ( |  | ) | const

inherited

Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

## proxy_has_object()

bool wayland::server::resource_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## removed()

void zwp_tablet_pad_v2_t::removed | ( | bool | post = true | ) |

pad removed event

Sent when the pad has been removed from the system. When a tablet is removed its pad(s) will be removed too.

When this event is received, the client must destroy all rings, strips and groups that were offered by this pad, and issue wp_tablet_pad.destroy the pad itself.

Definition at line 6947 of file wayland-server-protocol-unstable.cpp.

## Member Data Documentation

## button_since_version

std::uint32_t wayland::server::zwp_tablet_pad_v2_t::button_since_version = 1

static constexpr

Minimum protocol version required for the button function.

Definition at line 6335 of file wayland-server-protocol-unstable.hpp.

## buttons_since_version

std::uint32_t wayland::server::zwp_tablet_pad_v2_t::buttons_since_version = 1

static constexpr

Minimum protocol version required for the buttons function.

Definition at line 6308 of file wayland-server-protocol-unstable.hpp.

## done_since_version

std::uint32_t wayland::server::zwp_tablet_pad_v2_t::done_since_version = 1

static constexpr

Minimum protocol version required for the done function.

Definition at line 6321 of file wayland-server-protocol-unstable.hpp.

## enter_since_version

std::uint32_t wayland::server::zwp_tablet_pad_v2_t::enter_since_version = 1

static constexpr

Minimum protocol version required for the enter function.

Definition at line 6349 of file wayland-server-protocol-unstable.hpp.

## group_since_version

std::uint32_t wayland::server::zwp_tablet_pad_v2_t::group_since_version = 1

static constexpr

Minimum protocol version required for the group function.

Definition at line 6270 of file wayland-server-protocol-unstable.hpp.

## leave_since_version

std::uint32_t wayland::server::zwp_tablet_pad_v2_t::leave_since_version = 1

static constexpr

Minimum protocol version required for the leave function.

Definition at line 6363 of file wayland-server-protocol-unstable.hpp.

## path_since_version

std::uint32_t wayland::server::zwp_tablet_pad_v2_t::path_since_version = 1

static constexpr

Minimum protocol version required for the path function.

Definition at line 6291 of file wayland-server-protocol-unstable.hpp.

## removed_since_version

std::uint32_t wayland::server::zwp_tablet_pad_v2_t::removed_since_version = 1

static constexpr

Minimum protocol version required for the removed function.

Definition at line 6379 of file wayland-server-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp